package jeliot.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import jeliot.theatre.*;

/**
  * @author Pekka Uronen
  *
  * NOT CURRENLY USED IN JELIOT!
  *
  * created         24.9.1999
  */
public class TheatrePopup extends MouseAdapter
        implements MouseMotionListener {

    JPopupMenu variableMenu = new JPopupMenu(); {
        JPopupMenu menu = variableMenu;
        JMenuItem menuItem;
        menuItem = new JMenuItem("Variable");
        menu.add(menuItem);
        menuItem = new JMenuItem("Show declaration");
        menu.add(menuItem);
    }
    
    JPopupMenu methodMenu = new JPopupMenu(); {
        JPopupMenu menu = methodMenu;
        JMenuItem menuItem;
        menuItem = new JMenuItem("Method");
        menu.add(menuItem);
        menuItem = new JMenuItem("Show declaration");
        menu.add(menuItem);
    }

    public void mouseEntered(MouseEvent evt) {
        handleMouseEvent(evt);
    }

    public void mouseExited(MouseEvent evt) {
        handleMouseEvent(evt);
    }

    public void mouseMoved(MouseEvent evt) {
        handleMouseEvent(evt);
    }

    public void mousePressed(MouseEvent evt) {
       // System.err.println("mousePressed");
       // if (evt.isPopupTrigger()) {
            showPopup(evt);
       // }
    }

    /** Implemented to conform to MouseMotionListener interface.
      */
    public void mouseDragged(MouseEvent evt) { }

    private void handleMouseEvent(MouseEvent evt) {
        int x = evt.getX();
        int y = evt.getY();
        Theatre theatre = (Theatre)evt.getComponent();

        Actor actor = theatre.getActorAt(x, y);
     //   theatre.setHighlightedActor(actor);
    }

    private void showPopup(MouseEvent evt) {
        int x = evt.getX();
        int y = evt.getY();
        Theatre theatre = (Theatre)evt.getComponent();

        Actor actor = theatre.getActorAt(x, y);
       // System.err.println("showPop:" +actor);
        if (actor != null) {
            JPopupMenu menu = null;
            if (actor instanceof VariableActor) {
                menu = variableMenu;
            }
            else if (actor instanceof Stage) {
                menu = methodMenu;
            }
            if (menu != null) {
                
            //System.err.println("showMenu:"+menu);
           //     menu.setSize(menu.getPreferredSize());
                menu.show(evt.getComponent(), evt.getX(), evt.getY());
            }
        }
    }
    
}
