package jeliot.parser.error;

import java.util.*;
import jeliot.parser.*;

/**
  * @author Pekka Uronen
  *
  * created         28.9.1999
  */
public class IllegalAssignmentException extends SemanticException {

    private PElement expr;
    {
        info = "Illegal Assignment";
    }
    
    
    
    public IllegalAssignmentException(PAssignmentExpr expr) {
        this.expr = expr;
    }
    
    public IllegalAssignmentException(PVariableDeclarator decl) {
        this.expr = decl;
    }
       
}