package jeliot.parser.error;

import java.util.*;
import jeliot.lang.*;
import jeliot.parser.*;

/**
  * @author Pekka Uronen
  *
  * created         27.9.1999
  */
public class NonexistentFieldException extends SemanticException {
    
    PVariableAccessExpr access;
    Type type;
    String name;
    
    public NonexistentFieldException(ReferenceType type, String name ) {
        this.type = type;
        this.name = name;
        info = "Unknown field " + name + " in class " + type;
    }
    
    public void setAccess(PVariableAccessExpr access) {
        this.access = access;
    }
    
}